<?php

namespace Drupal\pinmap\Geocoder\Providers;

use Drupal\pinmap\Geocoder\Provider;

/**
 * Class MapQuest.
 */
class MapQuest extends Provider {

  /**
   * {@inheritdoc}
   */
  const QUERY_URL = 'http://open.mapquestapi.com/geocoding/v1/address';
  /**
   * {@inheritdoc}
   */
  const SERVICE_URL = 'http://open.mapquestapi.com/geocoding/';

  /**
   * {@inheritdoc}
   */
  protected function buildQuery($address) {
    // @link http://open.mapquestapi.com/geocoding/
    return [
      'location' => $address,
      'outFormat' => 'json',
      'maxResults' => 1,
    ];
  }

  /**
   * {@inheritdoc}
   */
  protected function getCoordinates() {
    if (empty($this->result->results)) {
      return [];
    }

    return reset(reset($this->result->results)->locations)->latLng;
  }

}
